package cs108;

import java.util.ArrayList;
import java.util.List;
import java.util.SortedSet;

public final class LZWConcreteDecoder implements LZWDecoder {
    private final List<String> dict;
    private final int dictCapacity;

    public LZWConcreteDecoder(SortedSet<Character> alphabet, int dictCapacity) {
        if (! (dictCapacity >= alphabet.size()))
            throw new IllegalArgumentException("dict. capacity smaller than alphabet");

        List<String> dict = new ArrayList<>(dictCapacity);
        alphabet.forEach(c -> dict.add(String.valueOf(c)));

        this.dict = dict;
        this.dictCapacity = dictCapacity;
    }

    @Override
    public String decode(List<Integer> l) {
        StringBuilder r = new StringBuilder();
        String p = null;
        for (int i: l) {
            String s = (i < dict.size() ? dict.get(i) : p + p.charAt(0));
            if (dict.size() < dictCapacity && p != null)
                dict.add(p + s.charAt(0));
            r.append(s);
            p = s;
        }
        return r.toString();
    }
}
